import ts from 'typescript';
import { Program } from './estree/spec';
import { ESTreeComment, ESTreeToken, ParserOptions } from './temp-types-based-on-js-source';
declare type AST<T extends ParserOptions> = Program & (T['range'] extends true ? {
    range: [number, number];
} : {}) & (T['tokens'] extends true ? {
    tokens: ESTreeToken[];
} : {}) & (T['comment'] extends true ? {
    comments: ESTreeComment[];
} : {});
interface ParseAndGenerateServicesResult<T extends ParserOptions> {
    ast: AST<T>;
    services: {
        program: ts.Program | undefined;
        esTreeNodeToTSNodeMap: WeakMap<object, any> | undefined;
        tsNodeToESTreeNodeMap: WeakMap<object, any> | undefined;
    };
}
export declare const version: string;
export declare function parse<T extends ParserOptions = ParserOptions>(code: string, options?: T): AST<T>;
export declare function parseAndGenerateServices<T extends ParserOptions = ParserOptions>(code: string, options: T): ParseAndGenerateServicesResult<T>;
export { AST_NODE_TYPES } from './ast-node-types';
export { ParserOptions };
